library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;

entity tb_FILTER is
		Generic ( T : time := 100 ns);
end tb_FILTER;

architecture behav of tb_FILTER is

    component FILTER
        port (
			  RESN       : in std_logic;
              MCLK       : in std_logic;
              MDAT       : in std_logic;
              SINC3_OUT  : out std_logic_vector (15 downto 0);
              SINC3_DONE : out std_logic;
              CNR_TEST   : out std_logic
			  );
    end component;

    signal RESN       : std_logic;
    signal MCLK       : std_logic := '0';
    signal MDAT       : std_logic := '0';
    signal SINC3_OUT  : std_logic_vector (15 downto 0);
    signal SINC3_DONE : std_logic;
    signal CNR_TEST   : std_logic;


--++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	signal data 	: std_logic_vector(24 downto 0);
	signal count	: std_logic := '0';
--********************************************************************

	
BEGIN


--=========================== CLOCK ==================================
    MCLK <= not MCLK after T / 2; 				-- Clock 50 ns
	
	
--=========================== RESET ==================================
		
RESET : process
		begin
			RESN <= '0'; wait for T ;  
			RESN <= '1'; 
			wait;
		end process;
		
--=========================== DIVIDER CLOCK =========================
divider: process
begin
CNR_TEST 	<= '0';
loop -- forever
	for k in 1 to 5 loop --
		wait on MCLK;
	end loop;
CNR_TEST 	<= not CNR_TEST ;
end loop;
end process;
	

-- *********** generating serial data ************************

data <= "1100110010101010101001011";

Integrator : 	process
				begin
				  for i in 24 downto 0 loop
					  wait until MCLK'event  and  MCLK ='1';
					  MDAT <= data(i);
				 end loop;
				end process;

			--	 count <= MDAT;
differentiator : process
				begin
					for i in 24 downto 0 loop
						wait until CNR_TEST'event and  CNR_TEST ='1';
						count <= data(i);
					end loop;
				end process;			 


--*****************************************************************************
   -- -- Stimulus process
   -- stim_proc: process
   -- begin	
		-- wait until rising_edge(TbClock);
		
		 -- SINC3_OUT_INT <= "1011101010110010101010101"; -- 17565555 
		 -- wait for T + 10 ns;
		 -- SINC3_OUT_INT <= "0011101010110000101010101"; -- 0756155
		 -- wait for T + 20 ns; 
		 -- SINC3_OUT_INT <= "1111111010110010101010101"; -- 1FD6555
		 -- wait for T + 30 ns;
		 -- SINC3_OUT_INT <= "1111101010110000101011111"; -- 1F561F5
		-- wait;
   -- end process;
	-- SINC3_OUT <= SINC3_OUT_INT(24 downto 9);
-------------------------------------------------------------------------
    dut : FILTER	port map (
							  RESN       => RESN,
							  MCLK       => MCLK,
							  MDAT       => MDAT,
							  SINC3_OUT  => SINC3_OUT,
							  SINC3_DONE => SINC3_DONE,
							  CNR_TEST   => CNR_TEST
							  );
			  
end behav;

